/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include	"sgl.h"
#include	"sega_cdc.h"
#include        "fl_cdda.h"

//extern char sddrvstsk[];
//extern char sddrvs[];
//extern char sddrvs_end[];

/*
  from sega_cdc.h

  #define CDC_PLY_STYPE(ply)          CDC_POS_PTYPE(&CDC_PLY_START(ply))
  #define CDC_PLY_START(ply)          ((ply)->start)
  #define CDC_POS_PTYPE(pos)          ((pos)->ptype)
  #define CDC_PLY_STNO(ply)           CDC_POS_TNO(&CDC_PLY_START(ply))
  #define CDC_POS_TNO(pos)            ((pos)->pbody.trkidx.tno)
  #define CDC_PLY_SIDX(ply)           CDC_POS_IDX(&CDC_PLY_START(ply))
  #define CDC_POS_IDX(pos)            ((pos)->pbody.trkidx.idx)
  #define CDC_PLY_ETYPE(ply)          CDC_POS_PTYPE(&CDC_PLY_END(ply))
  #define CDC_PLY_END(ply)            ((ply)->end)
  #define CDC_POS_PTYPE(pos)          ((pos)->ptype)
  #define CDC_PLY_ETNO(ply)           CDC_POS_TNO(&CDC_PLY_END(ply))
  #define CDC_POS_TNO(pos)            ((pos)->pbody.trkidx.tno)
 */


void fl_cdda_playcd(int track){

  //  int i,y=0;
  CdcPly plywk;
  CdcPly *ply = &plywk;

  //  slInitSystem(TV_320x224, NULL, 1);		
  // slPrint("Sound Driver Corruption Test v1",slLocate(1,y++));

  //  slInitSound(sddrvs , (sddrvs_end-sddrvs) , (Uint8 *)map , (4));
  
  CDC_CdInit(0x00,0x00,0x05,0x0f) ;
  
  /* start */ 

  // (&((ply)->start))->ptype = CDC_PTYPE_TNO ;    
  CDC_PLY_STYPE(ply) = CDC_PTYPE_TNO ;      

  // (&(((ply)->start)))->pbody.trkidx.tno)   = 2 ;   
  // was :   CDC_PLY_STNO(ply)  = 2 ;          
  CDC_PLY_STNO(ply)  = track ;          

  // (&((ply)->start))->pbody.trkidx.idx = 1;
  CDC_PLY_SIDX(ply) = 1 ;


  /* stop */

  // (&((ply)->end))->ptype = CDC_PTYPE_TNO ;
  CDC_PLY_ETYPE(ply) = CDC_PTYPE_TNO ;

  // (&((ply)->end))->pbody.trkidx.tno = 2;
  // was :  CDC_PLY_ETNO(ply)  = 2 ;
  CDC_PLY_ETNO(ply)  = track ;

  //  (&((ply)->end))->pbody.trkidx.idx = 99;
  CDC_PLY_EIDX(ply) = 99 ;

  /*
    #define CDC_PM_DFL          0x00    
    #define CDC_PM_REP_NOCHG    0x7f   
    #define CDC_PM_PIC_NOCHG    0x80    
    #define CDC_PM_NOCHG        -1     
    ((ply)->pmode) = 0x00 + 10 ;
  */

  // CDC_PLY_PMODE(ply) = CDC_PM_DFL+ 10 ;
  CDC_PLY_PMODE(ply) = 10 ;
  CDC_CdPlay(ply);
  
  slCDDAOn(127,127,0,0);
  slSndVolume(127);

}

