/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "fl_pict.h"
#include "pic_view/vbt_file.h"
#include "pic_view/vbt_gfx.h"

extern int sprintf (char *, const char *, ...);


int fl_picture_load(FL_PICTURE* p,unsigned short prefix){
  int ok = 0;
  char filename[50];
  char filenamePal[50];


  sprintf(filename,"I%03d.BIN",prefix);
  sprintf(filenamePal,"I%03d.PAL",prefix);
  /*
  slPrint(filename,slLocate(5,5));
  slPrint(filenamePal,slLocate(5,6));
  */
  
  if (LoadFile(filename, p->bitfield, 192)==0) { //taille /16000   
    ok = 1;
    slSynch();
    load_color_proms(filenamePal,p->palette);
  }
  return (ok);
}

void fl_picture_display(FL_PICTURE* p){
    selectPic(p->bitfield,p->palette);
}

void fl_picture_load_and_forget(unsigned short prefix){
    FL_PICTURE pic;
    fl_picture_load(&pic,prefix);
    fl_picture_display(&pic);

}
