/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include    "help.h"
#include    "fldefs.h"
#include    "pic_view/gfxconst.h" // background
#include    "pic_view/vbt_file.h" // cd file loading
#include    "libpad.h"
#include    "fl_pict.h"

void help_display(){
  
  int last_scr, scr;
  int out = 0;
    
  last_scr = -1; 
  scr = 0;
  
  while (!out){

    if (scr != last_scr){
      fl_picture_load_and_forget(HELP_SLIDE_FIRST + scr);
      last_scr = scr;
    }
    
    if (pad_someone_presses(PER_DGT_TB,1)) {      // backward
      last_scr = scr;
      scr = ((--scr)<0)?0:scr;
    } else if (pad_someone_presses(PER_DGT_TC,1)){       // forward
      last_scr = scr;
      scr = ((++scr)>=HELP_SLIDE_NB)?(HELP_SLIDE_NB-1):scr;
    }

    out = ((pad_someone_presses(PER_DGT_TR,1)||pad_someone_presses(PER_DGT_ST,0)));	
    
    slSynch();  
  }
}
