/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include "libpad.h"

int p_pad[] = {0,1,2,3,4,5,15,16,17,18,19,20};  // physical pad number

int pad_someone_presses(Uint16 value, int push){
  int i;
  Uint16 padpd;
  int pressed = 0;
  for (i=0;i<MAX_PAD_NB;i++){
    if (push) {
      padpd = ~(Smpc_Peripheral[p_pad[i]].push);
    } else {
      padpd = ~(Smpc_Peripheral[p_pad[i]].data);
    }
    pressed =  ((pressed) || (padpd & value)); 
  }
  return (pressed);
}

// 1->0
Uint16 pad_GetDownFront (Uint16 prev, Uint16 cur) {
  Uint16 downfront;
  downfront = (~((~prev) & cur));  
  return downfront;
}

// 0->1
Uint16 pad_GetUpFront (Uint16 prev, Uint16 cur) {
  Uint16 upfront = 0;
  upfront = pad_GetDownFront(cur,prev);
  return upfront;
}

