/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include    <sl_def.h>
#include    <ss_scrol.h>

#include    <sega_sys.h>
#include    "gfxconst.h"



//---------------------------------------------------------------------------------------------------------------

void initPicField(){
/*
  
  slTVOff();
  slColRAMMode(CRM16_1024);
  slBack1ColSet((void *)BACK_COL_ADR, 0);
  slColRAMOffsetNbg1(0);
  
  slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));
  slCharNbg1(COL_TYPE_256,CHAR_SIZE_1x1);
  slMapNbg1((void*)NBG1_MAP_ADR,(void*)NBG1_MAP_ADR,(void*)NBG1_MAP_ADR,(void*)NBG1_MAP_ADR);
  
  slInitBitMap(bmNBG1, BM_1024x512,(void *)NBG1_CEL_ADR);
  slBitMapBase(0,0);
  slBMPaletteNbg1(1);
  slScrAutoDisp(NBG0ON|NBG1ON);
  slTVOn();
  
*/
}
/*
void selectPic(unsigned char pic[],unsigned short palette[])
{
  slTVOff();
  Pal2CRAM(palette , (void *)NBG1_COL_ADR , 256) ;
  slClearBitMap(0);
  slBMPut(0,0,319,239, pic); // 512x256 + zoom x// 1/y 1 //a remettre
  slScrAutoDisp(NBG0ON|NBG1ON);
  slTVOn();  
  
}
*/

void selectPic(unsigned char pic[],unsigned short palette[])
{
	slTVOff();
	slColRAMMode(CRM16_1024);
	slBack1ColSet((void *)BACK_COL_ADR, 0);
	slColRAMOffsetNbg1(0);
//-----------------
	slScrPosNbg1(toFIXED(0.0), toFIXED(0.0));
	slCharNbg1(COL_TYPE_256,CHAR_SIZE_1x1);
	slMapNbg1((void*)NBG1_MAP_ADR,(void*)NBG1_MAP_ADR,(void*)NBG1_MAP_ADR,(void*)NBG1_MAP_ADR);
	Pal2CRAM(palette , (void *)NBG1_COL_ADR , 256) ;
//-----------------
	slBMPaletteNbg1(1);
	// slInitBitMap(bmNBG1, BM_1024x512,(void *)NBG1_CEL_ADR);

	slInitBitMap(bmNBG1,BM_512x256,(void *)NBG1_CEL_ADR);

	//slBitMapBase(160, 100);
	//slBMPut(-125,-116, 124, 115, pic); // 512x256 + zoom x// 1/y 1 //a remettre
	slBitMapBase(0,0);
	slBMPut(0,0,319,239, pic); // 512x256 + zoom x// 1/y 1 //a remettre

//-----------------

	slScrAutoDisp(NBG0ON|NBG1ON);
    slTVOn();
}

//---------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------

void Cel2VRAM( Uint8 *Cel_Data , void *Cell_Adr , Uint32 suu )
{
  Uint32 i;
  Uint8 *VRAM;

  VRAM = (Uint8 *)Cell_Adr;

  for( i = 0; i < suu; i++ )
    *(VRAM++) = *(Cel_Data++);
}

//---------------------------------------------------------------------------------------------------------------

void Map2VRAM( Uint16 *Map_Data , void *Map_Adr , Uint16 suuj , Uint16 suui , Uint16 palnum ,Uint32 mapoff)
{
  Uint16 i , j;
  Uint16 paloff;
  Uint16 *VRAM;

  paloff= palnum << 12;
  VRAM = (Uint16 *)Map_Adr;
	

  for( i = 0; i < suui; i++ ) {
    for( j = 0; j < suuj; j++ ) {
      *VRAM++ = (*Map_Data | paloff) + mapoff;
      Map_Data++;
    }
    VRAM += (64 - suuj);
  }
}

//---------------------------------------------------------------------------------------------------------------

void Pal2CRAM( Uint16 *Pal_Data , void *Col_Adr , Uint32 suu )
{
  Uint16 i;
  Uint16 *VRAM;

  VRAM = (Uint16 *)Col_Adr;

  for( i = 0; i < suu; i++ )
    *(VRAM++) = *(Pal_Data++);
}




void rotateCRAM(void *Col_Adr , Uint32 suu){
  Uint16 i;
  unsigned char first;
  Uint16 *VRAM;

  VRAM = (Uint16 *)Col_Adr;
  // sauvegarde le premier 
  first =  *(VRAM);
  // remplace i par i+1
  for (i=1;i<suu;i++){
    *(VRAM) = *(VRAM+1);
    VRAM++;
  }
  *(VRAM) = first;

}

int fadeCRAM(void *Col_Adr , Uint32 su){
  int over;
  Uint16 *VRAM;
  VRAM = (Uint16 *)Col_Adr;

  while ((*(VRAM) == (unsigned char)0)&& (su>0)){
    VRAM++;
    su--;
  }
  over = (!(su>0));
  if (!over) {
    (*(VRAM))=((unsigned char)0);
  }
  return over;
}
