/*

floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "sgl.h"
#ifndef CIPIU_H
#define CIPIU_H

typedef enum _LOGICAL_POS {lop_bal, lop_bal_under, lop_bal_under_ground, lop_bal_over, lop_a1, lop_a2, lop_d1, lop_d2,lop_bal_top_left,lop_bal_top_right} LOGICAL_POS;

typedef enum _CIPIU_MUSCLE_CONTROL {cc_left=0, cc_right, cc_up, cc_b,cc_last} CIPIU_MUSCLE_CONTROL;

typedef struct {
  struct _PLAYER *p;        
  int timeout;
  LOGICAL_POS target;
  int fire_bonus;
  FIXED default_pos[XY];
  int muscle_timeout[cc_last];
  int bonus_timeout;
} CIPIU;

void cipiu_init(CIPIU* c, void *p);
void cipiu_play(CIPIU* c, void *g, void *b);
void cipiu_think_now(CIPIU* c);


#endif






