/*
floupix ping pong - A multiplayer game for saturn
Copyright (C) 2004 SSMTF

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PATICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "sgl.h"

  /*
   * PADS
   */
    
  /*
    with <p_pad> and <MAX_PAD_NB>, all pads can be sequencialy selected.
    ex : 
    if multitap is plugged in port 1
    p_pad[0] = 0 ... p_pad[5] = 6 , p_pad[6] = 15 (= second port)
  */
  
  
  
#define MAX_PAD_NB 12
  
  
  
  
  // test all pads with value <value>, push true -> .push  else -> .data
  int pad_someone_presses(Uint16 value, int push);

/* 
 * Up and downfront. Requires previous state. 
 */
Uint16 pad_GetDownFront (Uint16 prev, Uint16 cur);
Uint16 pad_GetUpFront   (Uint16 prev, Uint16 cur);



